<template>
	<ProviderCustomColors v-bind="getColorProps($props)">
		<section :id="id" :class="$style.captionSection" :style="{ backgroundColor }">
			<div
				:class="[$style.captionCopy, { [$style.topBorder]: addTopBorder }, { [$style.botBorder]: addBottomBorder }]"
				:style="{ borderColor }"
			>
				<div v-rich-content :class="$style.mainText" v-html="column1Copy" />
				<div v-rich-content :class="$style.otherText" v-html="column2Copy" />
				<div v-rich-content :class="$style.otherText" v-html="column3Copy" />
			</div>
		</section>
	</ProviderCustomColors>
</template>

<script>
import ProviderCustomColors, { getColorProps } from '@components/provider-custom-colors';

export default {
	components: { ProviderCustomColors },

	props: {
		id: {
			type: String,
			default: null,
		},

		column1Copy: {
			type: [String, Array],
			default: '',
		},

		column2Copy: {
			type: [String, Array],
			default: '',
		},

		column3Copy: {
			type: [String, Array],
			default: '',
		},

		addTopBorder: {
			type: Boolean,
			default: false,
		},

		addBottomBorder: {
			type: Boolean,
			default: false,
		},

		borderColor: {
			type: String,
			default: '',
		},

		backgroundColor: {
			type: String,
			default: '',
		},

		copyColor: {
			type: String,
			default: '',
		},
	},

	methods: { getColorProps },
};
</script>

<style lang="scss" module>
@import '@design';

.captionSection {
	max-width: break('xxlarge');
	padding: 0 5rem;
	margin: 0 auto;
}

.captionCopy {
	display: flex;
	justify-content: center;
	padding: 6rem 0;
	margin: auto;
	text-align: center;

	@include above('medium') {
		display: grid;
		gap: 4rem;
		grid-template-columns: 6fr 3fr 3fr;
		padding: 6.5rem 0 10rem 0;
		text-align: left;
	}

	@include above('large') {
		grid-template-columns: 7.6fr 3fr 3fr;
		padding: 7.8rem 0 12rem 0;
	}

	&.topBorder {
		border-top: 1px solid;
	}

	&.botBorder {
		border-bottom: 1px solid;
	}
}

.mainText {
	@include use-text-style('heading-180');

	max-width: 40.7rem;
	font-family: font-family('secondary');
	line-height: 1.1667;
}

.otherText {
	@include use-text-style('type-500');

	max-width: 24.2rem;
	font-weight: 300;
	line-height: 1.3333;

	&:last-child {
		justify-self: flex-end;
	}

	@include below('medium') {
		display: none;
	}
}
</style>
